"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .token_enum import TokenEnum
from compassapisdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


AmountTokenDesiredTypedDict = TypeAliasType(
    "AmountTokenDesiredTypedDict", Union[float, str]
)
r"""The amount of token you want to provide"""


AmountTokenDesired = TypeAliasType("AmountTokenDesired", Union[float, str])
r"""The amount of token you want to provide"""


AmountEthDesiredTypedDict = TypeAliasType(
    "AmountEthDesiredTypedDict", Union[float, str]
)
r"""The amount of WETH you want to provide"""


AmountEthDesired = TypeAliasType("AmountEthDesired", Union[float, str])
r"""The amount of WETH you want to provide"""


AerodromeAddLiquidityEthParamsAmountTokenMinTypedDict = TypeAliasType(
    "AerodromeAddLiquidityEthParamsAmountTokenMinTypedDict", Union[float, str]
)
r"""The minimal amount of token you are willing to provide"""


AerodromeAddLiquidityEthParamsAmountTokenMin = TypeAliasType(
    "AerodromeAddLiquidityEthParamsAmountTokenMin", Union[float, str]
)
r"""The minimal amount of token you are willing to provide"""


AerodromeAddLiquidityEthParamsAmountEthMinTypedDict = TypeAliasType(
    "AerodromeAddLiquidityEthParamsAmountEthMinTypedDict", Union[float, str]
)
r"""The minimal amount of WETH you are willing to provide"""


AerodromeAddLiquidityEthParamsAmountEthMin = TypeAliasType(
    "AerodromeAddLiquidityEthParamsAmountEthMin", Union[float, str]
)
r"""The minimal amount of WETH you are willing to provide"""


class AerodromeAddLiquidityEthParamsTypedDict(TypedDict):
    r"""Endpoint parameters for adding ETH liquidity on Aerodrome Basic.

    This action is performed on the Aerodrome Basic Router to add liquidity to a pool
    with ETH as one of the tokens.
    """

    token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    stable: bool
    r"""If true, try to provide liquidity on a stable pool with a bonding curve of K=x^3y+y^3x. If false, try to provide liquidity on a volatile pool with a bonding curve of K=xy"""
    amount_token_desired: AmountTokenDesiredTypedDict
    r"""The amount of token you want to provide"""
    amount_eth_desired: AmountEthDesiredTypedDict
    r"""The amount of WETH you want to provide"""
    amount_token_min: AerodromeAddLiquidityEthParamsAmountTokenMinTypedDict
    r"""The minimal amount of token you are willing to provide"""
    amount_eth_min: AerodromeAddLiquidityEthParamsAmountEthMinTypedDict
    r"""The minimal amount of WETH you are willing to provide"""
    deadline: Nullable[int]
    r"""The deadline for this transaction in seconds since epoch"""
    to: NotRequired[Nullable[str]]
    r"""The receiver of the LP tokens from this trade, default to sender"""


class AerodromeAddLiquidityEthParams(BaseModel):
    r"""Endpoint parameters for adding ETH liquidity on Aerodrome Basic.

    This action is performed on the Aerodrome Basic Router to add liquidity to a pool
    with ETH as one of the tokens.
    """

    token: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    stable: bool
    r"""If true, try to provide liquidity on a stable pool with a bonding curve of K=x^3y+y^3x. If false, try to provide liquidity on a volatile pool with a bonding curve of K=xy"""

    amount_token_desired: AmountTokenDesired
    r"""The amount of token you want to provide"""

    amount_eth_desired: AmountEthDesired
    r"""The amount of WETH you want to provide"""

    amount_token_min: AerodromeAddLiquidityEthParamsAmountTokenMin
    r"""The minimal amount of token you are willing to provide"""

    amount_eth_min: AerodromeAddLiquidityEthParamsAmountEthMin
    r"""The minimal amount of WETH you are willing to provide"""

    deadline: Nullable[int]
    r"""The deadline for this transaction in seconds since epoch"""

    to: OptionalNullable[str] = UNSET
    r"""The receiver of the LP tokens from this trade, default to sender"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["to"]
        nullable_fields = ["to", "deadline"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
