"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .feeenum import FeeEnum
from .token_enum import TokenEnum
from compassapisdk.types import BaseModel
from typing import Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


UniswapBuyExactlyParamsAmountOutTypedDict = TypeAliasType(
    "UniswapBuyExactlyParamsAmountOutTypedDict", Union[float, str]
)
r"""The amount of the token to swap to"""


UniswapBuyExactlyParamsAmountOut = TypeAliasType(
    "UniswapBuyExactlyParamsAmountOut", Union[float, str]
)
r"""The amount of the token to swap to"""


UniswapBuyExactlyParamsAmountInMaximumTypedDict = TypeAliasType(
    "UniswapBuyExactlyParamsAmountInMaximumTypedDict", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


UniswapBuyExactlyParamsAmountInMaximum = TypeAliasType(
    "UniswapBuyExactlyParamsAmountInMaximum", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


class UniswapBuyExactlyParamsTypedDict(TypedDict):
    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """
    amount_out: UniswapBuyExactlyParamsAmountOutTypedDict
    r"""The amount of the token to swap to"""
    amount_in_maximum: UniswapBuyExactlyParamsAmountInMaximumTypedDict
    r"""The maximum amount of the token to swap from"""
    wrap_eth: NotRequired[bool]
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""


class UniswapBuyExactlyParams(BaseModel):
    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    amount_out: UniswapBuyExactlyParamsAmountOut
    r"""The amount of the token to swap to"""

    amount_in_maximum: UniswapBuyExactlyParamsAmountInMaximum
    r"""The maximum amount of the token to swap from"""

    wrap_eth: Optional[bool] = False
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""
