"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chain import Chain
from .feeenum import FeeEnum
from .token_enum import TokenEnum
from compassapisdk.types import BaseModel
from typing import Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


UniswapBuyExactlyRequestAmountOutTypedDict = TypeAliasType(
    "UniswapBuyExactlyRequestAmountOutTypedDict", Union[float, str]
)
r"""The amount of the token to swap to"""


UniswapBuyExactlyRequestAmountOut = TypeAliasType(
    "UniswapBuyExactlyRequestAmountOut", Union[float, str]
)
r"""The amount of the token to swap to"""


UniswapBuyExactlyRequestAmountInMaximumTypedDict = TypeAliasType(
    "UniswapBuyExactlyRequestAmountInMaximumTypedDict", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


UniswapBuyExactlyRequestAmountInMaximum = TypeAliasType(
    "UniswapBuyExactlyRequestAmountInMaximum", Union[float, str]
)
r"""The maximum amount of the token to swap from"""


class UniswapBuyExactlyRequestTypedDict(TypedDict):
    r"""Request model for buying exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """
    amount_out: UniswapBuyExactlyRequestAmountOutTypedDict
    r"""The amount of the token to swap to"""
    amount_in_maximum: UniswapBuyExactlyRequestAmountInMaximumTypedDict
    r"""The maximum amount of the token to swap from"""
    chain: Chain
    r"""The chain to use."""
    sender: str
    r"""The address of the transaction sender."""
    wrap_eth: NotRequired[bool]
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""


class UniswapBuyExactlyRequest(BaseModel):
    r"""Request model for buying exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    amount_out: UniswapBuyExactlyRequestAmountOut
    r"""The amount of the token to swap to"""

    amount_in_maximum: UniswapBuyExactlyRequestAmountInMaximum
    r"""The maximum amount of the token to swap from"""

    chain: Chain
    r"""The chain to use."""

    sender: str
    r"""The address of the transaction sender."""

    wrap_eth: Optional[bool] = False
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""
