"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .feeenum import FeeEnum
from .token_enum import TokenEnum
from compassapisdk.types import BaseModel
from typing import Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


UniswapSellExactlyParamsAmountInTypedDict = TypeAliasType(
    "UniswapSellExactlyParamsAmountInTypedDict", Union[float, str]
)
r"""The amount of the token to swap from"""


UniswapSellExactlyParamsAmountIn = TypeAliasType(
    "UniswapSellExactlyParamsAmountIn", Union[float, str]
)
r"""The amount of the token to swap from"""


UniswapSellExactlyParamsAmountOutMinimumTypedDict = TypeAliasType(
    "UniswapSellExactlyParamsAmountOutMinimumTypedDict", Union[float, str]
)
r"""The minimum amount of the token to swap to, defaults to 0"""


UniswapSellExactlyParamsAmountOutMinimum = TypeAliasType(
    "UniswapSellExactlyParamsAmountOutMinimum", Union[float, str]
)
r"""The minimum amount of the token to swap to, defaults to 0"""


class UniswapSellExactlyParamsTypedDict(TypedDict):
    r"""Parameters model for selling exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """
    amount_in: UniswapSellExactlyParamsAmountInTypedDict
    r"""The amount of the token to swap from"""
    amount_out_minimum: NotRequired[UniswapSellExactlyParamsAmountOutMinimumTypedDict]
    r"""The minimum amount of the token to swap to, defaults to 0"""
    wrap_eth: NotRequired[bool]
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""


class UniswapSellExactlyParams(BaseModel):
    r"""Parameters model for selling exactly an amount of tokens."""

    token_in: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    fee: FeeEnum
    r"""The transaction fee of a Uniswap pool in bips.

    Uniswap supports 4 different fee levels.
    """

    amount_in: UniswapSellExactlyParamsAmountIn
    r"""The amount of the token to swap from"""

    amount_out_minimum: Optional[UniswapSellExactlyParamsAmountOutMinimum] = None
    r"""The minimum amount of the token to swap to, defaults to 0"""

    wrap_eth: Optional[bool] = False
    r"""Whether to wrap ETH to WETH, only use when swapping WETH into something"""
